package xyz.etztech.minecraftmanager;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import org.bukkit.ChatColor;

public class MCMResponse {
    private Boolean status;
    private String message;
    private JsonElement extra;

    public MCMResponse(JsonArray httpResponse) {
        JsonObject json = httpResponse.get(0).getAsJsonObject();
        setStatus(json.get("status").getAsBoolean());
        setMessage(json.get("message").getAsString());
        setExtra(json.get("extra"));
    }

    public MCMResponse(JsonObject httpResponse) {
        setStatus(httpResponse.get("status").getAsBoolean());
        setMessage(httpResponse.get("message").getAsString());
        setExtra(httpResponse.get("extra"));
    }

    public Boolean getStatus() {
        return status;
    }

    public void setStatus(Boolean status) {
        this.status = status;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public JsonElement getExtra() {
        return extra;
    }

    public void setExtra(JsonElement extra) {
        this.extra = extra;
    }

    public String getMCMessage() {
        if (status) {
            return ChatColor.GREEN + message;
        } else {
            return ChatColor.RED + message;
        }
    }

}
