package xyz.etztech.minecraftmanager;

import net.md_5.bungee.api.chat.ComponentBuilder;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.TextComponent;
import org.apache.commons.lang.StringUtils;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class MCMUtil {
    private static FileWriter globalFile;
    public static PrintWriter globalLog;
    private static FileWriter staffFile;
    public static PrintWriter staffLog;

    public static void init() {
        MinecraftManager plugin = (MinecraftManager) Bukkit.getPluginManager().getPlugin("MinecraftManager");
        String pluginPath = plugin.getDataFolder().getAbsolutePath();
        String globalPath = pluginPath + "/logs/global.log";
        try {
            globalFile = new FileWriter(globalPath, true);
            globalLog = new PrintWriter(globalFile);
        } catch (Exception e) {
            plugin.log("Could not connect to global log (" + globalPath + ").");
        }
        if (plugin.getConfig().getBoolean("staff-chat.enabled")) {
            String staffPath = pluginPath + "/logs/staff.log";
            try {
                staffFile = new FileWriter(staffPath, true);
                staffLog = new PrintWriter(staffFile);
            } catch (Exception e) {
                plugin.log("Could not connect to staff log (" + staffPath + ").");
            }
        }
    }

    public static void staffMessage(String message) {
        staffMessage(message, null);
    }

    public static void staffMessage(String message, String command) {
        log(staffLog, message);
        HoverEvent hover = new HoverEvent(HoverEvent.Action.SHOW_TEXT, new ComponentBuilder("Staff Chat").create());
        TextComponent text = new TextComponent(message);
        text.setHoverEvent(hover);
        if (StringUtils.isNotEmpty(command)) {
            text.setClickEvent(new ClickEvent(ClickEvent.Action.RUN_COMMAND, command));
        }
        for (Player player : Bukkit.getServer().getOnlinePlayers()) {
            if (player.hasPermission("minecraftmanager.staff")) {
                player.spigot().sendMessage(text);
            }
        }
    }

    public static void globalMessage(String message) {
        log(globalLog, message);
        for (Player player : Bukkit.getServer().getOnlinePlayers()) {
            player.sendMessage(message);
        }
    }

    public static void log(PrintWriter logger, String message) {
        try {
            //[4/21/17 7:12 PM]
            //Bukkit.getServer().getConsoleSender().sendMessage(message);
            message = ChatColor.stripColor(message);
            Date date = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("M/d/yy hh:mm a");
            String text = "[" + sdf.format(date) + "] " + message;
            logger.append(text + "\n");
            logger.flush();
        } catch (Exception ex) {
            Bukkit.getServer().getConsoleSender().sendMessage("Could not log message! Check your log files!");
        }
    }
}
