package xyz.etztech.minecraftmanager.command;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import xyz.etztech.minecraftmanager.MinecraftManager;
import xyz.etztech.minecraftmanager.MinecraftManagerThread;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.List;

public class CommandRules implements CommandExecutor {

    MinecraftManager plugin;
    String rules;


    public CommandRules(MinecraftManager plugin) {
        this.plugin = plugin;

        reload();
    }

    public void reload() {
        List<String> rules = this.plugin.getConfig().getStringList("rules.rules");
        if (this.plugin.getConfig().getBoolean("rules.application.validate")) {
            String finalAnswer = this.plugin.getConfig().getString("rules.application.answer");
            rules.add("The answer for the final question is \"" + finalAnswer + "\"");
        }
        StringBuilder rulesMessage = new StringBuilder(ChatColor.GOLD + "===== Rules =====");
        for (int i = 0; i < rules.size(); i++) {
            rulesMessage.append("\n" + ChatColor.YELLOW + (i + 1) + ". " + rules.get(i));
        }
        this.rules = rulesMessage.toString();
    }


    @Override
    public boolean onCommand(CommandSender sender, Command command, String base, String[] args) {

        sender.sendMessage(this.rules);

        return true;
    }



}
