package xyz.etztech.minecraftmanager.listeners;

import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerLoginEvent;
import xyz.etztech.minecraftmanager.MCMAPI;
import xyz.etztech.minecraftmanager.MinecraftManager;

import java.util.ArrayList;
import java.util.List;

public class BlockBreakListener implements Listener {

    private MinecraftManager plugin;

    public BlockBreakListener(MinecraftManager minecraftManager) {
        this.plugin = minecraftManager;
    }

    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {

        Block block = event.getBlock();
        boolean isDiamond = Material.DIAMOND_ORE == block.getType();
        if (isDiamond) {
            boolean notify = MinecraftManager.addDiamond(getLocationString(block));
            for (Block radiusBlock : getBlocks(block, 5)) {
                MinecraftManager.addDiamond(getLocationString(radiusBlock));
            }
            if (notify) {
                plugin.log("[OreAlert]: " + event.getPlayer().getName());
            }
        }
    }

    private List<Block> getBlocks(Block start, int radius) {
        if (radius < 0) {
            return new ArrayList<Block>(0);
        }
        int iterations = (radius * 2) + 1;
        List<Block> blocks = new ArrayList<Block>(iterations * iterations * iterations);
        for (int x = -radius; x <= radius; x++) {
            for (int y = -radius; y <= radius; y++) {
                for (int z = -radius; z <= radius; z++) {
                    blocks.add(start.getRelative(x, y, z));
                }
            }
        }
        return blocks;
    }

    private String getLocationString(Block block) {
        int X = block.getX();
        int Y = block.getY();
        int Z = block.getZ();

        String x = String.valueOf(X);
        String y = String.valueOf(Y);
        String z = String.valueOf(Z);

        return x + y + z;
    }


}
